<template>
	<h4>
		Namespace Filter
	</h4>
	<cdx-button @click="$emit( 'reset-filters' )">
		Reset namespace filter
	</cdx-button>
	<details class="wlh-namespace-filter">
		<summary>Namespaces</summary>
		<div class="wlh-namespace-filter__content">
			<cdx-checkbox
				v-for="ns in namespaces"
				:key="ns.id"
				:input-value="ns.name"
				:model-value="namespaceSelection.includes( ns.id )"
				@update:model-value="onUpdate( ns.id )"
			>
				{{ ns.name || "Main" }}
			</cdx-checkbox>
		</div>
	</details>
</template>

<script lang="ts">
import { defineComponent, PropType } from 'vue';
import { CdxButton, CdxCheckbox } from '@wikimedia/codex';
import { Namespace } from '../types';

export default defineComponent( {
	name: 'SidebarFilters',
	components: {
		CdxButton,
		CdxCheckbox
	},
	props: {
		namespaces: {
			type: Array as PropType<Array<Namespace>>,
			default() {
				return [];
			}
		},
		namespaceSelection: {
			type: Array as PropType<Array<number>>,
			default() {
				return [];
			}
		}
	},
	emits: [
		'update-filters',
		'reset-filters'
	],
	setup( props, context ) {
		function onUpdate( id: number ) {
			context.emit( 'update-filters', id );
		}

		return {
			onUpdate
		};
	}
} );
</script>

<style lang="less">
@import (reference) '@wikimedia/codex-design-tokens/theme-wikimedia-ui.less';

.wlh-namespace-filter {
	margin-top: @spacing-100;
	font-size: 0.875em;

	summary {
		cursor: pointer;
		margin-bottom: @spacing-50;
	}

	&__content {
		padding: @spacing-50;
	}
}
</style>
